﻿#Область МетодыPost

//Функция экспортная, специально чтобы можно было отлаживать как по HTTP(https://its.1c.ru/db/metod8dev#content:5756:hdoc)
//Так и через внешнюю обработку
Функция HS_ОбработкаМетодовPOST(СтруктураВхПараметров) Экспорт
	//структура ответа. Собственна нужна для формирования ответа
	СтруктураОтвет = Новый Структура("ДанныеОтвета,Отработало,ТекстОшибки,КодОтвета","",Истина,"",200);
	
	//Переправляем на нужный метод
#Область ПримерыЧасть3	
//Получаем список заданий за период (БСП)		
	Если ВРег(СтруктураВхПараметров.ИмяМетода) = ВРег("ПолучитьСписокЗаданийЗаПериод") Тогда	
		
		HS_ОбработкаУниверсальныхМетодов.ПолучитьСписокЗаданийЗаПериод(СтруктураОтвет,СтруктураВхПараметров);
#КонецОбласти		
//Получаем количество элементов		
	ИначеЕсли ВРег(СтруктураВхПараметров.ИмяМетода) = ВРег("ПолучитьКоличествоЭлементовВариантЗапрос") Тогда	

		HS_ОбработкаУниверсальныхМетодов.ПолучитьКоличествоЭлементовВариантЗапрос(СтруктураОтвет,СтруктураВхПараметров);
		
//Порционно получаем элементы в формате JSON		
	ИначеЕсли ВРег(СтруктураВхПараметров.ИмяМетода) = ВРег("ПолучитьПорциюЭлементовВариантЗапроса") Тогда	

		HS_ОбработкаУниверсальныхМетодов.ПолучитьПорциюЭлементовВариантЗапроса(СтруктураОтвет,СтруктураВхПараметров);	
		
	ИначеЕсли ВРег(СтруктураВхПараметров.ИмяМетода) = ВРег("StatusDoc") Тогда	
		HS_ОбработкаУниверсальныхМетодов.ПолучитьДанныеПоСпискуНомеровДокументов(СтруктураОтвет,СтруктураВхПараметров);
	ИначеЕсли Врег(СтруктураВхПараметров.ИмяМетода) = ВРег("ListZakazFromINN") Тогда
		HS_ОбработкаУниверсальныхМетодов.ПолучитьСписокЗаказовПоИННКонтрагента(СтруктураОтвет,СтруктураВхПараметров);
	Иначе
		HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,501,"Отсутствует Метод " + ?(СтруктураВхПараметров.ИмяМетода=Неопределено,"",СтруктураВхПараметров.ИмяМетода),ложь,"");
	КонецЕсли;
	
	Возврат СтруктураОтвет;	
КонецФункции

#КонецОбласти 

#Область МетодыGet

//Функция экспортная, специально чтобы можно было отлаживать как по HTTP(https://its.1c.ru/db/metod8dev#content:5756:hdoc)
//Так и через внешнюю обработку
Функция HS_ОбработкаМетодовGET(СтруктураВхПараметров) Экспорт
	//структура ответа. Собственна нужна для формирования ответа
	СтруктураОтвет = Новый Структура("ДанныеОтвета,Отработало,ТекстОшибки,КодОтвета","",Истина,"",200);
	
	//Операцию нужно выполнить используя БСП:Базовая функциональность\Длительные операции++
#Область ПримерыЧасть3	
	ВФоне = СтруктураВхПараметров.ПараметрыЗапроса.Получить("BTask");
	Если не ВФоне = Неопределено Тогда
		ВФоне = Булево(ВФоне);
		Если ВФоне = Истина Тогда 
			УникальныйИдентификатор = Новый УникальныйИдентификатор;
			
			//Уникальный адрес результата
			АдресРезультата = СтруктураВхПараметров.ИмяМетода+"_"+Строка(УникальныйИдентификатор);
			
			//Подгатавливаем параметры для Длительной операции
			ПараметрыЗапуска = ДлительныеОперации.ПараметрыВыполненияВФоне(УникальныйИдентификатор);
			ПараметрыЗапуска.НаименованиеФоновогоЗадания = "Выполнение_" + АдресРезультата;	
			ПараметрыЗапуска.ОжидатьЗавершение = Ложь;
			ПараметрыЗапуска.КлючФоновогоЗадания = УникальныйИдентификатор;
			ПараметрыЗапуска.ЗапуститьВФоне = Истина;
			
			//Добавляем адрес в структуру
			СтруктураВхПараметров.Вставить("АдресРезультата",АдресРезультата);
			
			//Запускаем метод в фоне
			РезультатФоновогоЗадания = ДлительныеОперации.ВыполнитьВФоне(
				"HS_АсинхронныеОперации.ФЗ_ВыполнитьМетод_ДлительнаяОперация",
				СтруктураВхПараметров,
				ПараметрыЗапуска);
				
			//Проверяем что задание запустилось	
			Если РезультатФоновогоЗадания.Статус = "Ошибка" Тогда
				HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,400,"Ошибка при формировании: "+Строка(РезультатФоновогоЗадания.КраткоеПредставлениеОшибки),Ложь,"");	
				Возврат СтруктураОтвет;
			КонецЕсли;	
			
			ФоновоеЗаданиеИдентификатор  = РезультатФоновогоЗадания.ИдентификаторЗадания;
			
			АдресСсылки = СтруктураВхПараметров.БазовыйURL + "/V1/ФоновоеЗаданиеПроверить?" +
						"Result_Key=" + АдресРезультата + "&" +
						"Task_Key=" + Строка(ФоновоеЗаданиеИдентификатор);
			
			//Формируем html ответ
			СтруктураОтвет.ДанныеОтвета = "<html>
					 |<body>
					 | <b>Задание отправлено на выполнение!</b><br>					 
					 | <p>Идентификатор фонового задания = " + Строка(ФоновоеЗаданиеИдентификатор) + "<br>  
					 | Адрес хранилища результата = " + АдресРезультата + "</p>
					 | <p><a href=""" + АдресСсылки + """>Ссылка на получение результата</a></p> 
					 |</body>
					 |</html>";
			
			Возврат СтруктураОтвет;
		КонецЕсли;	
	КонецЕсли;	
#КонецОбласти	
	//Операцию нужно выполнить используя БСП:Базовая функциональность\Длительные операции--

#Область ПримерыЧасть1	
	//Переправляем на нужный метод
	Если ВРег(СтруктураВхПараметров.ИмяМетода) = ВРег("Список") Тогда
		
		ПолучитьСписок(СтруктураОтвет,СтруктураВхПараметров);	
		
	ИначеЕсли ВРег(СтруктураВхПараметров.ИмяМетода) = ВРег("Документ") Тогда

		ПолучитьДокумент(СтруктураОтвет,СтруктураВхПараметров);
		
#КонецОбласти
#Область ПримерыЧасть2
//Получаем доступные остатки по складу в формате JSON (ERP, УТ, КА)	
	ИначеЕсли ВРег(СтруктураВхПараметров.ИмяМетода) = ВРег("ОстаткиИДоступностьТоваровПоСкладу") Тогда
		
		HS_ОбработкаУниверсальныхМетодов.ПолучитьОстаткиИДоступностьТоваровПоСкладу(СтруктураОтвет,СтруктураВхПараметров);	
#КонецОбласти
#Область ПримерыЧасть3
//Получаем список заданий за период (БСП)		
	ИначеЕсли ВРег(СтруктураВхПараметров.ИмяМетода) = ВРег("ПолучитьСписокЗаданийЗаПериод") Тогда	

		HS_ОбработкаУниверсальныхМетодов.ПолучитьСписокЗаданийЗаПериод(СтруктураОтвет,СтруктураВхПараметров);
		
//Проверяем фоновое задание. Если Выполнено забираем результат		
	ИначеЕсли ВРег(СтруктураВхПараметров.ИмяМетода) = ВРег("ФоновоеЗаданиеПроверить") Тогда	
		
		ПроверитьФоновоеЗадание(СтруктураОтвет,СтруктураВхПараметров);
		
#КонецОбласти		

//Получаем количество элементов		
	ИначеЕсли ВРег(СтруктураВхПараметров.ИмяМетода) = ВРег("ПолучитьКоличествоЭлементовВариантЗапрос") Тогда	

		HS_ОбработкаУниверсальныхМетодов.ПолучитьКоличествоЭлементовВариантЗапрос(СтруктураОтвет,СтруктураВхПараметров);
		
//Порционно получаем элементы в формате JSON		
	ИначеЕсли ВРег(СтруктураВхПараметров.ИмяМетода) = ВРег("ПолучитьПорциюЭлементовВариантЗапроса") Тогда	

		HS_ОбработкаУниверсальныхМетодов.ПолучитьПорциюЭлементовВариантЗапроса(СтруктураОтвет,СтруктураВхПараметров);		
				
	Иначе
		HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,501,"Отсутствует Метод " + ?(СтруктураВхПараметров.ИмяМетода=Неопределено,"",СтруктураВхПараметров.ИмяМетода),Ложь,"");
	КонецЕсли;
	Возврат СтруктураОтвет;	
КонецФункции

#Область Методы
#Область ПримерыЧасть1
Процедура ПолучитьСписок(СтруктураОтвет,СтруктураВхПараметров)
	Результат = "Расходная накладная, 1, 01.01.2014
	|Расходная накладная, 2, 01.01.2014";
	СтруктураОтвет.ДанныеОтвета = Результат;
КонецПроцедуры	

Процедура ПолучитьДокумент(СтруктураОтвет,СтруктураВхПараметров)
	//ПраметрыЗапроса - number
	ПарНомер = СтруктураВхПараметров.ПараметрыЗапроса.Получить("number");

	Номер = Число(?(ПарНомер=Неопределено,0,ПарНомер));
	Если Номер > 2 Тогда
		HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,400,"Отсутствует документ с номером: " + Номер,ложь,"");
	Иначе	
		Если Номер = 1 Тогда
			Результат = "Расходная накладная, 1, 01.01.2014";
		Иначе
			Результат = "Расходная накладная, 2, 01.01.2014";
		КонецЕсли;
		СтруктураОтвет.ДанныеОтвета = Результат;	
	КонецЕсли;
КонецПроцедуры	
#КонецОбласти
#Область ПримерыЧасть3
Процедура ПроверитьФоновоеЗадание(СтруктураОтвет,СтруктураВхПараметров)
	перФоновоеЗаданиеИдентификатор  = СтруктураВхПараметров.ПараметрыЗапроса.Получить("Task_Key");
	АдресРезультата = СтруктураВхПараметров.ПараметрыЗапроса.Получить("Result_Key");
	
	//Проверяем фоновое задание
	Если перФоновоеЗаданиеИдентификатор = Неопределено Тогда 
		Задание = HS_ОбщиеПроцедурыИФункции.НайтиЗадание(Неопределено);
	Иначе
		//Получаем Уникальный идентификатор задания
		ФоновоеЗаданиеИдентификатор = Новый УникальныйИдентификатор(перФоновоеЗаданиеИдентификатор);
		
		Задание = HS_ОбщиеПроцедурыИФункции.НайтиЗадание(ФоновоеЗаданиеИдентификатор);
	КонецЕсли;
	
	//При отсутствии адреса результата прерываем
	Если АдресРезультата = Неопределено Тогда 
		HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,400,"Отсутствует параметр ""Result_Key""",Ложь,"");
		Возврат;
	КонецЕсли;	
	
		Если Не Задание.Выполняется Тогда
		Попытка
			НайденнаяСсылка = Справочники.HS_ХранилищеРезультатов.НайтиПоРеквизиту("АдресРезультата",АдресРезультата);
			
			Если НайденнаяСсылка = Справочники.HS_ХранилищеРезультатов.ПустаяСсылка() Тогда
				//Можно вынести в отдельную функцию
				АдресСсылки = СтруктураВхПараметров.БазовыйURL + "/V1/ФоновоеЗаданиеПроверить?" +
						"Result_Key=" + АдресРезультата + ?(ЗначениеЗаполнено(перФоновоеЗаданиеИдентификатор),
						"&Task_Key=" + перФоновоеЗаданиеИдентификатор,"");
		
				//Формируем html ответ	
				СтруктураОтвет.ДанныеОтвета = "<html>
							 |<body>
							 | <b>Задание еще выполняется, попробуйте получить результат позже!</b><br>
							 | <p>Идентификатор фонового задания = " + перФоновоеЗаданиеИдентификатор + "<br>  
							 | Адрес хранилища результата = " + АдресРезультата + "</p>
							 |<p><a href=""" + АдресСсылки + """>Ссылка на получение результата</a></p>  
							 |</body>
					 		 |</html>";	
			Иначе
				СтруктураОтвет = НайденнаяСсылка.Результат.Получить();
			КонецЕсли;

		Исключение
			HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,400,"Ошибка при формировании: "+ОписаниеОшибки(),Ложь,"");	
		КонецПопытки;	
	Иначе
		//Задание еще в процессе
		АдресСсылки = СтруктураВхПараметров.БазовыйURL + "/V1/ФоновоеЗаданиеПроверить?" +
						"Result_Key=" + АдресРезультата + ?(ЗначениеЗаполнено(перФоновоеЗаданиеИдентификатор),
						"&Task_Key=" + перФоновоеЗаданиеИдентификатор,"");
		
		//Формируем html ответ	
		СтруктураОтвет.ДанныеОтвета = "<html>
					 |<body>
					 | <b>Задание еще выполняется, попробуйте получить результат позже!</b><br>
					 | <p>Идентификатор фонового задания = " + перФоновоеЗаданиеИдентификатор + "<br>  
					 | Адрес хранилища результата = " + АдресРезультата + "</p>
					 |<p><a href=""" + АдресСсылки + """>Ссылка на получение результата</a></p>  
					 |</body>
					 |</html>";	
	КонецЕсли;	
КонецПроцедуры	
#КонецОбласти
#КонецОбласти
	
#КонецОбласти 