﻿#Область Методы
//Пример из Части 2. Метод написан под ERP, будет работать в УТ и КА
#Область ПримерыЧасть2
Процедура ПолучитьОстаткиИДоступностьТоваровПоСкладу(СтруктураОтвет,СтруктураВхПараметров) Экспорт 
	//ПраметрыЗапроса - number
	Склад_Key = СтруктураВхПараметров.ПараметрыЗапроса.Получить("Ref_Key");

	Если не Склад_Key = Неопределено Тогда
		//Получаем Склад
		Попытка
			Склад = XMLЗначение(Тип("СправочникСсылка.Склады"), Склад_Key); 
		Исключение
			Склад = Неопределено;
		КонецПопытки;
		
		Если ЗначениеЗаполнено(Склад) Тогда 
			//Получаем схему компоновки и вариант отчета
			//СхемаКомпоновки = Отчеты.ОстаткиИДоступностьТоваров.ПолучитьМакет("ОсновнаяСхемаКомпоновкиДанных");
			//ВариантНастроеки = СхемаКомпоновки.ВариантыНастроек.Найти("ОстаткиИДоступностьТоваров");	
			СхемаКомпоновки = Отчеты.HS_ХранилищеМакетов.ПолучитьМакет("СКД_ОстаткиИДоступностьТоваров_HTTP");
			ВариантНастроеки = СхемаКомпоновки.ВариантыНастроек.Найти("ОстаткиИДоступностьТоваровНеТаблица");
			НастройкиКомпоновки = ВариантНастроеки.Настройки;	
				
			//Взято из модуля отчета.ОстаткиИДоступностьТоваров "ПриКомпоновкеРезультата"++	
			ТекстЗапроса = СхемаКомпоновки.НаборыДанных.Основной.Запрос;

			ТекстЗапроса = СтрЗаменить(
				ТекстЗапроса, 
				"&ТекстЗапросаВесНоменклатуры", 
				Справочники.УпаковкиЕдиницыИзмерения.ТекстЗапросаВесУпаковки("Набор.Номенклатура.ЕдиницаИзмерения", "Набор.Номенклатура"));
					
			ТекстЗапроса = СтрЗаменить(
				ТекстЗапроса, 
				"&ТекстЗапросаОбъемНоменклатуры", 
				Справочники.УпаковкиЕдиницыИзмерения.ТекстЗапросаОбъемУпаковки("Набор.Номенклатура.ЕдиницаИзмерения", "Набор.Номенклатура"));

			СхемаКомпоновки.НаборыДанных.Основной.Запрос = ТекстЗапроса;
			//Взято из модуля отчета.ОстаткиИДоступностьТоваров "ПриКомпоновкеРезультата"--                           	
					
			ПрараметрОтбора = НастройкиКомпоновки.Отбор.Элементы;
			СкладПолеКомпоновки = Новый ПолеКомпоновкиДанных("Склад");
			Для Каждого СтрокаОтбора из ПрараметрОтбора Цикл 
				Если СтрокаОтбора.ЛевоеЗначение = СкладПолеКомпоновки  Тогда
					СтрокаОтбора.Использование 	= Истина;
					СтрокаОтбора.ВидСравнения 	= ВидСравненияКомпоновкиДанных.Равно;
					СтрокаОтбора.ПравоеЗначение = Склад; 	
				КонецЕсли;
			КонецЦикла;	
						
			КомпоновщикМакета = Новый КомпоновщикМакетаКомпоновкиДанных;
			
			МакетКомпоновки = КомпоновщикМакета.Выполнить(СхемаКомпоновки, НастройкиКомпоновки, , , Тип("ГенераторМакетаКомпоновкиДанныхДляКоллекцииЗначений"));
				
			ПроцессорКомпоновки = Новый ПроцессорКомпоновкиДанных;     
			ПроцессорКомпоновки.Инициализировать(МакетКомпоновки,,,Истина);
			
			ПроцессорВывода = Новый ПроцессорВыводаРезультатаКомпоновкиДанныхВКоллекциюЗначений;     
			ДеревоЗначений = Новый ДеревоЗначений;     
			ПроцессорВывода.УстановитьОбъект(ДеревоЗначений);         	
			ПроцессорВывода.Вывести(ПроцессорКомпоновки);
				
			//Обходим дерево и формируем РезультатОтвет
			РезультатОтвет = Новый Массив;
			Для Каждого ВерхнийУровеньДерева Из ДеревоЗначений.Строки Цикл	
				Для Каждого ПодчиненныйУровеньДерева Из ВерхнийУровеньДерева.Строки Цикл	
					Если ЗначениеЗаполнено(ПодчиненныйУровеньДерева.Номенклатура) 
						И ТипЗнч(ПодчиненныйУровеньДерева.Номенклатура) = Тип("СправочникСсылка.Номенклатура") 
					Тогда 
						РезультатОтвет.Добавить(Новый Структура("ИмяЗначение,Артикул,Guid,ДоступноСейчас,Остаток",
						ПодчиненныйУровеньДерева.Номенклатура.Наименование +
							?(ЗначениеЗаполнено(ПодчиненныйУровеньДерева.Характеристика),
								","+Строка(ПодчиненныйУровеньДерева.Характеристика),""),
						ПодчиненныйУровеньДерева.НоменклатураАртикул,
						XMLСтрока(ПодчиненныйУровеньДерева.Номенклатура),
						ПодчиненныйУровеньДерева.ДоступноСейчас,
						ПодчиненныйУровеньДерева.ВНаличии));
					КонецЕсли;	
				КонецЦикла;
			КонецЦикла;
				
			//РезультатОтвет в JSON
			ВхПараметры = HS_ОбщиеПроцедурыИФункции.СтандартныеПараметрыJSON();
			СтруктураОтвет.ДанныеОтвета = HS_ОбщиеПроцедурыИФункции.ЗаписатьДанныеВJSON(ВхПараметры,РезультатОтвет);

			СтруктураОтвет.Вставить("ФорматОтвета",HS_ОбщиеПроцедурыИФункции.ФорматОтветаJSON());
			
		Иначе
			HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,400,"Не заполнен или неверно заполнен параметр ""Ref_Key""",ложь,"");	
		КонецЕсли;	
	Иначе
		HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,400,"Отсутствует параметр ""Ref_Key""",ложь,"");	
	КонецЕсли;	
КонецПроцедуры	

Процедура ПолучитьДанныеПоСпискуНомеровДокументов(СтруктураОтвет,СтруктураВхПараметров) Экспорт
	//ВидДокументов - получаем для идентификации того, что будем искать изначально
	//Должен принимать вид Schet или Zakaz
	
	//ЗаписьЖурналаРегистрации("HTTP-Service",,,СтруктураВхПараметров,"ВАЖНОЕ",);
	
	ЧтениеJSON = Новый ЧтениеJSON;
	ЧтениеJSON.УстановитьСтроку(СтруктураВхПараметров.ТелоЗапроса);
	СтруктураJSON = ПрочитатьJSON(ЧтениеJSON);
	
	ВидКонтрагента = СтруктураJSON.urfiz;//принимаем данные по клиенту, если urfiz = ur то юр.лицо; 
	
	//СтрокаСпискаНомеровДокументов - Строка с номерами документов, разделенными запятыми без пробелов. 
	//Только цифры и кирилические символы в верхнем регистре.
	СтрокаСпискаНомеровДокументов = СтруктураJSON.strNumDoc; //СтруктураВхПараметров.ПараметрыЗапроса.Получить("StrDocNumbers"); 
	СтрокаСпискаНомеровДокументов = Врег(СтрЗаменить(СтрокаСпискаНомеровДокументов," ","")); //Убираем все пробелы и переводим в верхний регистр
	МассивНомеровДокументов = СтрРазделить(СтрокаСпискаНомеровДокументов,",",ЛОЖЬ);
	
	ИННКонтрагента = СтруктураJSON.INN;
	
	Если НЕ ВидКонтрагента = Неопределено Тогда
		Если ВидКонтрагента = "ur" Тогда //отрабатываем с ИНН по Юр.Лицу
			
			Запрос = Новый Запрос;
			Запрос.Текст = "ВЫБРАТЬ
			               |	СчетНаОплатуПокупателю.ЗаявкаОснование КАК ЗаявкаОснование
			               |ИЗ
			               |	Документ.СчетНаОплатуПокупателю КАК СчетНаОплатуПокупателю
			               |ГДЕ
			               |	СчетНаОплатуПокупателю.Номер В(&МассивНомеров)
			               |	И СчетНаОплатуПокупателю.Контрагент.ЮридическоеФизическоеЛицо = ЗНАЧЕНИЕ(Перечисление.ЮридическоеФизическоеЛицо.ЮридическоеЛицо)
			               |	И СчетНаОплатуПокупателю.Контрагент.ИНН = &ИННКонтрагента";
			Запрос.УстановитьПараметр("МассивНомеров",МассивНомеровДокументов);
			Запрос.УстановитьПараметр("ИННКонтрагента",ИННКонтрагента);
			Выполнение = Запрос.Выполнить();
			ТЗВыгрузка = Выполнение.Выгрузить();
			Запрос = "";
			
			//Здесь получаем ТЗ Заявок. Теперь нужно из ТЗ выдернуть Номера Заявок и добавить эти номера к МассивуНомеровДокументов
			Для каждого СтрокаТЗ Из ТЗВыгрузка Цикл
				МассивНомеровДокументов.Добавить(СтрокаТЗ.ЗаявкаОснование.Номер);
			КонецЦикла; 
			
			//Все Номера Счетов Отработали.
			//Теперь можно просто собрать данные по заявкам.
			Запрос = Новый Запрос;
			Запрос.Текст = "ВЫБРАТЬ
			               |	ЗаказКлиента.Ссылка КАК Заявка,
			               |	ВЫБОР
			               |		КОГДА ЗаказКлиента.Контрагент.НаименованиеСокращенное = NULL
			               |				ИЛИ ЗаказКлиента.Контрагент.НаименованиеСокращенное = """"
			               |			ТОГДА ЗаказКлиента.Контрагент.НаименованиеПолное
			               |		ИНАЧЕ ЗаказКлиента.Контрагент.НаименованиеСокращенное
			               |	КОНЕЦ КАК Контрагент,
			               |	ВЫБОР
			               |		КОГДА НЕ СостоянияДокументов.Состояние ЕСТЬ NULL
			               |			ТОГДА СостоянияДокументов.Состояние.Представление
			               |		ИНАЧЕ ""Без статуса""
			               |	КОНЕЦ КАК Статус
			               |ПОМЕСТИТЬ Заявки
			               |ИЗ
			               |	Документ.ЗаказКлиента КАК ЗаказКлиента
			               |		ЛЕВОЕ СОЕДИНЕНИЕ РегистрСведений.СостоянияДокументов КАК СостоянияДокументов
			               |		ПО ЗаказКлиента.Ссылка = СостоянияДокументов.Документ
			               |ГДЕ
			               |	ЗаказКлиента.Номер В(&МассивНомеров)
			               |	И ЗаказКлиента.Контрагент.ЮридическоеФизическоеЛицо = ЗНАЧЕНИЕ(Перечисление.ЮридическоеФизическоеЛицо.ЮридическоеЛицо)
			               |	И ЗаказКлиента.Контрагент.ИНН = &ИННКонтрагента
			               |;
			               |
			               |////////////////////////////////////////////////////////////////////////////////
			               |ВЫБРАТЬ
			               |	СчетНаОплатуПокупателю.Ссылка КАК Счет,
			               |	ВЫБОР
			               |		КОГДА ОплатаСчетовПокупателями.Сумма > 0
			               |			ТОГДА ""Оплата есть""
			               |		ИНАЧЕ ""Оплаты нет""
			               |	КОНЕЦ КАК НаличиеОплаты,
			               |	ЕСТЬNULL(ОплатаСчетовПокупателями.Сумма, 0) КАК СуммаОплаты,
			               |	СчетНаОплатуПокупателю.ЗаявкаОснование КАК ЗаявкаОснование
			               |ПОМЕСТИТЬ Счета
			               |ИЗ
			               |	Документ.СчетНаОплатуПокупателю КАК СчетНаОплатуПокупателю
			               |		ЛЕВОЕ СОЕДИНЕНИЕ РегистрНакопления.ОплатаСчетовПокупателями КАК ОплатаСчетовПокупателями
			               |		ПО СчетНаОплатуПокупателю.Ссылка = ОплатаСчетовПокупателями.Счет
			               |ГДЕ
			               |	СчетНаОплатуПокупателю.ЗаявкаОснование В
			               |			(ВЫБРАТЬ
			               |				Заявки.Заявка КАК ЗаказКлиента
			               |			ИЗ
			               |				Заявки КАК Заявки)
			               |;
			               |
			               |////////////////////////////////////////////////////////////////////////////////
			               |ВЫБРАТЬ
			               |	Заявки.Контрагент КАК Контрагент,
			               |	Заявки.Заявка КАК Заявка,
			               |	Заявки.Статус КАК Статус,
			               |	Счета.Счет КАК Счет,
			               |	Счета.НаличиеОплаты КАК НаличиеОплаты,
			               |	Счета.СуммаОплаты КАК Оплата
			               |ИЗ
			               |	Заявки КАК Заявки
			               |		ЛЕВОЕ СОЕДИНЕНИЕ Счета КАК Счета
			               |		ПО Заявки.Заявка = Счета.ЗаявкаОснование";
			Запрос.УстановитьПараметр("МассивНомеров",МассивНомеровДокументов);
			Запрос.УстановитьПараметр("ИННКонтрагента",ИННКонтрагента);
			Выполнение = Запрос.Выполнить();
			ТЗЗапроса = Выполнение.Выгрузить();
			
			Если НЕ ТЗЗапроса.Количество()=0 Тогда
				ИтоговаяТЗ = Новый ТаблицаЗначений;
				ИтоговаяТЗ.Колонки.Добавить("Контрагент");
				ИтоговаяТЗ.Колонки.Добавить("Счет");
				ИтоговаяТЗ.Колонки.Добавить("Наличие_оплаты");
				ИтоговаяТЗ.Колонки.Добавить("Заявка");
				ИтоговаяТЗ.Колонки.Добавить("Статус");
				//ИтоговаяТЗ.Колонки.Добавить("Сумма_оплаты");
				
				Для каждого СтрТЗ Из ТЗЗапроса Цикл
					НовСтрИтоговойТЗ = ИтоговаяТЗ.Добавить();
					НовСтрИтоговойТЗ["Контрагент"] = СтрТЗ.Контрагент;
					Если ЗначениеЗаполнено(СтрТЗ.Заявка) Тогда
						НомерЗаявки = СокрЛП(Строка(СтрТЗ.Заявка.Номер));
						ДатаЗаявки = Строка(Формат(СтрТЗ.Заявка.Дата,"ДФ=dd.MM.yyyy; ДЛФ=D; ДП='Нет даты'"));
						НовСтрИтоговойТЗ["Заявка"] = Строка("№ " + НомерЗаявки + " от " + ДатаЗаявки);
					Иначе
						НовСтрИтоговойТЗ["Заявка"] = СтрТЗ.Заявка;
					КонецЕсли;
					Если ЗначениеЗаполнено(СтрТЗ.Счет) Тогда
						НомерСчета = СокрЛП(Строка(СтрТЗ.Счет.Номер));
						ДатаСчета = Строка(Формат(СтрТЗ.Счет.Дата,"ДФ=dd.MM.yyyy; ДЛФ=D; ДП='Нет даты'"));
						НовСтрИтоговойТЗ["Счет"] = Строка("№ " + НомерСчета + " от " + ДатаСчета);
					Иначе
						НовСтрИтоговойТЗ["Счет"] = ?(ЗначениеЗаполнено(СтрТЗ.Счет),СтрТЗ.Счет,"Счет не оформлен");
					КонецЕсли;
					
					НовСтрИтоговойТЗ["Статус"] = СтрТЗ.Статус;
					НовСтрИтоговойТЗ["Наличие_оплаты"] = ?(ЗначениеЗаполнено(СтрТЗ.НаличиеОплаты),СтрТЗ.НаличиеОплаты,"Оплаты нет");
					//НовСтрИтоговойТЗ["Сумма_оплаты"] = Формат(СтрТЗ.Оплата,"ЧЦ=12; ЧДЦ=2; ЧРД=,; ЧН=Пусто");
					//НовСтрИтоговойТЗ[""] = ;
				КонецЦикла; 
			Иначе	
				ИтоговаяТЗ = Новый ТаблицаЗначений;
				ИтоговаяТЗ.Колонки.Добавить("Результат");
				
				НовСтрИтоговойТЗ = ИтоговаяТЗ.Добавить();
				НовСтрИтоговойТЗ.Результат = "По вашему запросу ничего не найдено.";
			КонецЕсли; 
			
			РезультатЗапроса = HS_ОбщиеПроцедурыИФункции.ПреобразоватьТаблицуЗначенийВМассивСтруктур(ИтоговаяТЗ);
			
			//РезультатОтвет в JSON
			ВхПараметры = HS_ОбщиеПроцедурыИФункции.СтандартныеПараметрыJSON();
			СтруктураОтвет.ДанныеОтвета = HS_ОбщиеПроцедурыИФункции.ЗаписатьДанныеВJSON(ВхПараметры,РезультатЗапроса);

			СтруктураОтвет.Вставить("ФорматОтвета",HS_ОбщиеПроцедурыИФункции.ФорматОтветаJSON());
		ИначеЕсли ВидКонтрагента = "fiz" Тогда	//работаем по физику, инн не важен, условие только Контрагент - Физ.Лицо
			Запрос = Новый Запрос;
			Запрос.Текст = "ВЫБРАТЬ
			               |	СчетНаОплатуПокупателю.ЗаявкаОснование КАК ЗаявкаОснование
			               |ИЗ
			               |	Документ.СчетНаОплатуПокупателю КАК СчетНаОплатуПокупателю
			               |ГДЕ
			               |	СчетНаОплатуПокупателю.Номер В(&МассивНомеров)
			               |	И СчетНаОплатуПокупателю.Контрагент.ЮридическоеФизическоеЛицо = ЗНАЧЕНИЕ(Перечисление.ЮридическоеФизическоеЛицо.ФизическоеЛицо)";
			Запрос.УстановитьПараметр("МассивНомеров",МассивНомеровДокументов);
			Выполнение = Запрос.Выполнить();
			ТЗВыгрузка = Выполнение.Выгрузить();
			Запрос = "";
			
			//Здесь получаем ТЗ Заявок. Теперь нужно из ТЗ выдернуть Номера Заявок и добавить эти номера к МассивуНомеровДокументов
			Для каждого СтрокаТЗ Из ТЗВыгрузка Цикл
				МассивНомеровДокументов.Добавить(СтрокаТЗ.ЗаявкаОснование.Номер);
			КонецЦикла; 
			
			//Все Номера Счетов Отработали.
			//Теперь можно просто собрать данные по заявкам.
			
			Запрос = Новый Запрос;
			Запрос.Текст = "ВЫБРАТЬ
			               |	ЗаказКлиента.Ссылка КАК Заявка,
			               |	""Физическое лицо"" КАК Контрагент,
			               |	ВЫБОР
			               |		КОГДА НЕ СостоянияДокументов.Состояние ЕСТЬ NULL
			               |			ТОГДА СостоянияДокументов.Состояние.Представление
			               |		ИНАЧЕ ""Без статуса""
			               |	КОНЕЦ КАК Статус
			               |ПОМЕСТИТЬ Заявки
			               |ИЗ
			               |	Документ.ЗаказКлиента КАК ЗаказКлиента
			               |		ЛЕВОЕ СОЕДИНЕНИЕ РегистрСведений.СостоянияДокументов КАК СостоянияДокументов
			               |		ПО ЗаказКлиента.Ссылка = СостоянияДокументов.Документ
			               |ГДЕ
			               |	ЗаказКлиента.Номер В(&МассивНомеров)
			               |	И ЗаказКлиента.Контрагент.ЮридическоеФизическоеЛицо = ЗНАЧЕНИЕ(Перечисление.ЮридическоеФизическоеЛицо.ФизическоеЛицо)
			               |;
			               |
			               |////////////////////////////////////////////////////////////////////////////////
			               |ВЫБРАТЬ
			               |	СчетНаОплатуПокупателю.Ссылка КАК Счет,
			               |	ВЫБОР
			               |		КОГДА ОплатаСчетовПокупателями.Сумма > 0
			               |			ТОГДА ""Оплата есть""
			               |		ИНАЧЕ ""Оплаты нет""
			               |	КОНЕЦ КАК НаличиеОплаты,
			               |	ЕСТЬNULL(ОплатаСчетовПокупателями.Сумма, 0) КАК СуммаОплаты,
			               |	СчетНаОплатуПокупателю.ЗаявкаОснование КАК ЗаявкаОснование
			               |ПОМЕСТИТЬ Счета
			               |ИЗ
			               |	Документ.СчетНаОплатуПокупателю КАК СчетНаОплатуПокупателю
			               |		ЛЕВОЕ СОЕДИНЕНИЕ РегистрНакопления.ОплатаСчетовПокупателями КАК ОплатаСчетовПокупателями
			               |		ПО СчетНаОплатуПокупателю.Ссылка = ОплатаСчетовПокупателями.Счет
			               |ГДЕ
			               |	СчетНаОплатуПокупателю.ЗаявкаОснование В
			               |			(ВЫБРАТЬ
			               |				Заявки.Заявка КАК ЗаказКлиента
			               |			ИЗ
			               |				Заявки КАК Заявки)
			               |;
			               |
			               |////////////////////////////////////////////////////////////////////////////////
			               |ВЫБРАТЬ
			               |	Заявки.Контрагент КАК Контрагент,
			               |	Заявки.Заявка КАК Заявка,
			               |	Заявки.Статус КАК Статус,
			               |	Счета.Счет КАК Счет,
			               |	Счета.НаличиеОплаты КАК НаличиеОплаты,
			               |	Счета.СуммаОплаты КАК СуммаОплаты
			               |ИЗ
			               |	Заявки КАК Заявки
			               |		ЛЕВОЕ СОЕДИНЕНИЕ Счета КАК Счета
			               |		ПО Заявки.Заявка = Счета.ЗаявкаОснование";
			Запрос.УстановитьПараметр("МассивНомеров",МассивНомеровДокументов);
			Выполнение = Запрос.Выполнить();
			ТЗЗапроса = Выполнение.Выгрузить();
			
			Если НЕ ТЗЗапроса.Количество()=0 Тогда
				ИтоговаяТЗ = Новый ТаблицаЗначений;
				ИтоговаяТЗ.Колонки.Добавить("Контрагент");
				ИтоговаяТЗ.Колонки.Добавить("Счет");
				ИтоговаяТЗ.Колонки.Добавить("Наличие_оплаты");
				ИтоговаяТЗ.Колонки.Добавить("Заявка");
				ИтоговаяТЗ.Колонки.Добавить("Статус");
				//ИтоговаяТЗ.Колонки.Добавить("Сумма_оплаты");
				
				Для каждого СтрТЗ Из ТЗЗапроса Цикл
					НовСтрИтоговойТЗ = ИтоговаяТЗ.Добавить();
					НовСтрИтоговойТЗ["Контрагент"] = СтрТЗ.Контрагент;
					Если ЗначениеЗаполнено(СтрТЗ.Заявка) Тогда
						НомерЗаявки = СокрЛП(Строка(СтрТЗ.Заявка.Номер));
						ДатаЗаявки = Строка(Формат(СтрТЗ.Заявка.Дата,"ДФ=dd.MM.yyyy; ДЛФ=D; ДП='Нет даты'"));
						НовСтрИтоговойТЗ["Заявка"] = Строка("№ " + НомерЗаявки + " от " + ДатаЗаявки);
					Иначе
						НовСтрИтоговойТЗ["Заявка"] = СтрТЗ.Заявка;
					КонецЕсли;
					Если ЗначениеЗаполнено(СтрТЗ.Счет) Тогда
						НомерСчета = СокрЛП(Строка(СтрТЗ.Счет.Номер));
						ДатаСчета = Строка(Формат(СтрТЗ.Счет.Дата,"ДФ=dd.MM.yyyy; ДЛФ=D; ДП='Нет даты'"));
						НовСтрИтоговойТЗ["Счет"] = Строка("№ " + НомерСчета + " от " + ДатаСчета);
					Иначе
						НовСтрИтоговойТЗ["Счет"] = ?(ЗначениеЗаполнено(СтрТЗ.Счет),СтрТЗ.Счет,"Счет не оформлен");
					КонецЕсли;
					
					НовСтрИтоговойТЗ["Статус"] = СтрТЗ.Статус;
					НовСтрИтоговойТЗ["Наличие_оплаты"] = ?(ЗначениеЗаполнено(СтрТЗ.НаличиеОплаты),СтрТЗ.НаличиеОплаты,"Оплаты нет");
					//НовСтрИтоговойТЗ["Сумма_оплаты"] = Формат(СтрТЗ.Оплата,"ЧЦ=12; ЧДЦ=2; ЧРД=,; ЧН=Пусто");
					//НовСтрИтоговойТЗ[""] = ;
				КонецЦикла; 
			Иначе	
				ИтоговаяТЗ = Новый ТаблицаЗначений;
				ИтоговаяТЗ.Колонки.Добавить("Результат");
				
				НовСтрИтоговойТЗ = ИтоговаяТЗ.Добавить();
				НовСтрИтоговойТЗ.Результат = "По вашему запросу ничего не найдено.";
			КонецЕсли; 
			
			РезультатЗапроса = HS_ОбщиеПроцедурыИФункции.ПреобразоватьТаблицуЗначенийВМассивСтруктур(ИтоговаяТЗ);
			
			//РезультатОтвет в JSON
			ВхПараметры = HS_ОбщиеПроцедурыИФункции.СтандартныеПараметрыJSON();
			СтруктураОтвет.ДанныеОтвета = HS_ОбщиеПроцедурыИФункции.ЗаписатьДанныеВJSON(ВхПараметры,РезультатЗапроса);

			СтруктураОтвет.Вставить("ФорматОтвета",HS_ОбщиеПроцедурыИФункции.ФорматОтветаJSON());
		Иначе
			HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,400,"Не заполнен или неверно заполнен параметр ""urfiz""",ложь,"");	
		КонецЕсли;	
	Иначе
		HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,400,"Не указан параметр ""urfiz""",ложь,"");	
	КонецЕсли;
КонецПроцедуры

Процедура ПолучитьСписокЗаказовПоИННКонтрагента(СтруктураОтвет,СтруктураВхПараметров) Экспорт
	ЧтениеJSON = Новый ЧтениеJSON;
	ЧтениеJSON.УстановитьСтроку(СтруктураВхПараметров.ТелоЗапроса);
	СтруктураJSON = ПрочитатьJSON(ЧтениеJSON);
	
	ИННКонтрагента = СокрЛП(СтруктураJSON.INNContragent);
	
	Если НЕ ИННКонтрагента = Неопределено И СтрДлина(ИННКонтрагента)<>0 Тогда
		Запрос = Новый Запрос;
		Запрос.Текст = "ВЫБРАТЬ
		               |	ЗаказКлиента.Представление КАК Заявка,
		               |	ВЫБОР
		               |		КОГДА ЗаказКлиента.Контрагент.ЮридическоеФизическоеЛицо = ЗНАЧЕНИЕ(Перечисление.ЮридическоеФизическоеЛицо.ЮридическоеЛицо)
		               |			ТОГДА ВЫБОР
		               |					КОГДА ЗаказКлиента.Контрагент.НаименованиеСокращенное = NULL
		               |							ИЛИ ЗаказКлиента.Контрагент.НаименованиеСокращенное = """"
		               |						ТОГДА ЗаказКлиента.Контрагент.НаименованиеПолное
		               |					ИНАЧЕ ЗаказКлиента.Контрагент.НаименованиеСокращенное
		               |				КОНЕЦ
		               |		ИНАЧЕ ""Физическое лицо""
		               |	КОНЕЦ КАК Контрагент,
		               |	ВЫБОР
		               |		КОГДА НЕ СостоянияДокументов.Состояние ЕСТЬ NULL
		               |			ТОГДА СостоянияДокументов.Состояние.Представление
		               |		ИНАЧЕ ""Без статуса""
		               |	КОНЕЦ КАК СтатусЗаявки,
		               |	ЗаказКлиента.Ссылка КАК ЗаявкаЗаказ
		               |ПОМЕСТИТЬ Заявки
		               |ИЗ
		               |	Документ.ЗаказКлиента КАК ЗаказКлиента
		               |		ЛЕВОЕ СОЕДИНЕНИЕ РегистрСведений.СостоянияДокументов КАК СостоянияДокументов
		               |		ПО ЗаказКлиента.Ссылка = СостоянияДокументов.Документ
		               |ГДЕ
		               |	ЗаказКлиента.Контрагент.ИНН = &ИННКонтрагента
		               |	И ЗаказКлиента.Проведен = ИСТИНА
		               |;
		               |
		               |////////////////////////////////////////////////////////////////////////////////
		               |ВЫБРАТЬ
		               |	СчетНаОплатуПокупателю.Представление КАК Счет,
		               |	ВЫБОР
		               |		КОГДА ОплатаСчетовПокупателями.Сумма > 0
		               |			ТОГДА ""Оплата есть""
		               |		ИНАЧЕ ""Оплаты нет""
		               |	КОНЕЦ КАК НаличиеОплаты,
		               |	ЕСТЬNULL(ОплатаСчетовПокупателями.Сумма, 0) КАК СуммаОплаты,
		               |	СчетНаОплатуПокупателю.ЗаявкаОснование КАК ЗаявкаОснование
		               |ПОМЕСТИТЬ Счета
		               |ИЗ
		               |	Документ.СчетНаОплатуПокупателю КАК СчетНаОплатуПокупателю
		               |		ЛЕВОЕ СОЕДИНЕНИЕ РегистрНакопления.ОплатаСчетовПокупателями КАК ОплатаСчетовПокупателями
		               |		ПО СчетНаОплатуПокупателю.Ссылка = ОплатаСчетовПокупателями.Счет
		               |ГДЕ
		               |	СчетНаОплатуПокупателю.ЗаявкаОснование В
		               |			(ВЫБРАТЬ
		               |				Заявки.ЗаявкаЗаказ КАК ЗаказКлиента
		               |			ИЗ
		               |				Заявки КАК Заявки)
		               |;
		               |
		               |////////////////////////////////////////////////////////////////////////////////
		               |ВЫБРАТЬ
		               |	Заявки.Контрагент КАК Контрагент,
		               |	Заявки.Заявка КАК Заявка,
		               |	Заявки.СтатусЗаявки КАК СтатусЗаявки,
		               |	ЕСТЬNULL(Счета.Счет, """") КАК Счет,
		               |	ЕСТЬNULL(Счета.НаличиеОплаты, ""Оплаты нет"") КАК НаличиеОплаты,
		               |	ЕСТЬNULL(Счета.СуммаОплаты, 0) КАК СуммаОплаты
		               |ИЗ
		               |	Заявки КАК Заявки
		               |		ЛЕВОЕ СОЕДИНЕНИЕ Счета КАК Счета
		               |		ПО Заявки.ЗаявкаЗаказ = Счета.ЗаявкаОснование";
		Запрос.УстановитьПараметр("ИННКонтрагента",ИННКонтрагента);
		Выполнение = Запрос.Выполнить();
		
		РезультатЗапроса = HS_ОбщиеПроцедурыИФункции.ПреобразоватьТаблицуЗначенийВМассивСтруктур(Выполнение.Выгрузить());
		
		//РезультатОтвет в JSON
		ВхПараметры = HS_ОбщиеПроцедурыИФункции.СтандартныеПараметрыJSON();
		СтруктураОтвет.ДанныеОтвета = HS_ОбщиеПроцедурыИФункции.ЗаписатьДанныеВJSON(ВхПараметры,РезультатЗапроса);
		
		СтруктураОтвет.Вставить("ФорматОтвета",HS_ОбщиеПроцедурыИФункции.ФорматОтветаJSON());
	Иначе
		HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,400,"Не указан параметр ""INNContragent""",ложь,"");	
	КонецЕсли;
КонецПроцедуры

#КонецОбласти

//Пример из Части 3. Метод написан под Демо БСП, следовательно будет работать в конфигурациях с БСП
#Область ПримерыЧасть3
Процедура ПолучитьСписокЗаданийЗаПериод(СтруктураОтвет,СтруктураВхПараметров) Экспорт 
	//Проверяем входящие параметры
	Если ВРег(СтруктураВхПараметров.МетодЗапроса) = ВРег("GET") Тогда 
		
		перНачалоПериода = СтруктураВхПараметров.ПараметрыЗапроса.Получить("StartPeriod");
		НачалоПериода = ?(перНачалоПериода = Неопределено,
					Неопределено,HS_ОбщиеПроцедурыИФункции.ПолучитьДатуВремяИзСтроки(перНачалоПериода));
			
		перКонецПериода = СтруктураВхПараметров.ПараметрыЗапроса.Получить("EndPeriod");
		КонецПериода = ?(перКонецПериода = Неопределено,
					Неопределено,HS_ОбщиеПроцедурыИФункции.ПолучитьДатуВремяИзСтроки(перКонецПериода));

	ИначеЕсли ВРег(СтруктураВхПараметров.МетодЗапроса) = ВРег("POST") Тогда
					
		ЧтениеJSON = Новый ЧтениеJSON;
		ЧтениеJSON.УстановитьСтроку(СтруктураВхПараметров.ТелоЗапроса);	
						
		Попытка
			ТелоЗапросаJSON = ПрочитатьJSON(ЧтениеJSON);
		Исключение
			HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,
				400,"Не удалось получить данные!",Ложь,"");
		КонецПопытки;
			
		Если СтруктураОтвет.Отработало Тогда
			Если ТипЗнч(ТелоЗапросаJSON) = Тип("Структура") Тогда 
				
				НачалоПериода = ?(ТелоЗапросаJSON.Свойство("StartPeriod"),
					HS_ОбщиеПроцедурыИФункции.ПолучитьДатуВремяИзСтроки(ТелоЗапросаJSON.StartPeriod),Неопределено);
					
				КонецПериода = ?(ТелоЗапросаJSON.Свойство("EndPeriod"),
					HS_ОбщиеПроцедурыИФункции.ПолучитьДатуВремяИзСтроки(ТелоЗапросаJSON.EndPeriod),Неопределено);	
			Иначе
				HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,
					400,"Передана не структура!",Ложь,"");
			КонецЕсли;	
		КонецЕсли;	
	Иначе
		HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,
			501,"Метод: "+СтруктураВхПараметров.МетодЗапроса+" не поддерживается!",Ложь,"");	
	КонецЕсли;	
	
	//Проверяем была ли ошибка
	Если СтруктураОтвет.Отработало Тогда
		//Получаем схему компоновки и вариант отчета
		СхемаКомпоновки 	= Отчеты.Задания.ПолучитьМакет("Макет");
		ВариантНастроеки 	= СхемаКомпоновки.ВариантыНастроек.Найти("СписокЗаданий");	
		НастройкиКомпоновки = ВариантНастроеки.Настройки;	
		
		//Взято из модуля отчета.Задания "ПриКомпоновкеРезультата"++			
		ИспользоватьДатуИВремяВСрокахЗадач = ПолучитьФункциональнуюОпцию("ИспользоватьДатуИВремяВСрокахЗадач");
		СрокИсполнения = СхемаКомпоновки.НаборыДанных[0].Поля.Найти("СрокИсполнения");
		СрокИсполнения.Оформление.УстановитьЗначениеПараметра("Формат", ?(ИспользоватьДатуИВремяВСрокахЗадач, "ДЛФ=DT", "ДЛФ=D"));	
		//Взято из модуля отчета.Задания "ПриКомпоновкеРезультата"--                           	
				
		Параметр = НастройкиКомпоновки.ПараметрыДанных.Элементы.Найти("Период");
		Если Параметр <> Неопределено Тогда
			Параметр.Использование = ?(ЗначениеЗаполнено(НачалоПериода) 
										ИЛИ ЗначениеЗаполнено(КонецПериода),Истина,Ложь);
				
			ПериодВрем = Новый СтандартныйПериод;
			Если ЗначениеЗаполнено(НачалоПериода) Тогда 
				ПериодВрем.ДатаНачала = НачалоДня(НачалоПериода);
			КонецЕсли;
			Если ЗначениеЗаполнено(КонецПериода) Тогда
				ПериодВрем.ДатаОкончания = КонецДня(КонецПериода);
			КонецЕсли;
			Если Параметр.Использование Тогда 
				Параметр.Значение = ПериодВрем;
			КонецЕсли;	
		КонецЕсли;
	
		КомпоновщикМакета = Новый КомпоновщикМакетаКомпоновкиДанных;
		
		МакетКомпоновки = КомпоновщикМакета.Выполнить(СхемаКомпоновки, НастройкиКомпоновки, , , Тип("ГенераторМакетаКомпоновкиДанныхДляКоллекцииЗначений"));
		
		ПроцессорКомпоновки = Новый ПроцессорКомпоновкиДанных;     
		ПроцессорКомпоновки.Инициализировать(МакетКомпоновки,,,Истина);
		
		ПроцессорВывода = Новый ПроцессорВыводаРезультатаКомпоновкиДанныхВКоллекциюЗначений;     
		ТЗ = Новый ТаблицаЗначений;     
		ПроцессорВывода.УстановитьОбъект(ТЗ);         	
		ПроцессорВывода.Вывести(ПроцессорКомпоновки);
		
		//Обходим ТЗ и формируем РезультатОтвет
		РезультатОтвет = Новый Массив;
		Для Каждого СтрокаТЗ Из ТЗ Цикл	
			Если ЗначениеЗаполнено(СтрокаТЗ.Ссылка) 
				И ТипЗнч(СтрокаТЗ.Ссылка) = Тип("БизнесПроцессСсылка.Задание") 
			Тогда 
				РезультатОтвет.Добавить(Новый Структура("Задание,Guid,Автор,Дата,Выполнено",
				СтрокаТЗ.Ссылка.Наименование,
				XMLСтрока(СтрокаТЗ.Ссылка),
				СтрокаТЗ.Автор.Наименование,
				СтрокаТЗ.Дата,
				СтрокаТЗ.Выполнено));
			КонецЕсли;	
			
		КонецЦикла;
		
		//РезультатОтвет в JSON
		ВхПараметры = HS_ОбщиеПроцедурыИФункции.СтандартныеПараметрыJSON();
		СтруктураОтвет.ДанныеОтвета = HS_ОбщиеПроцедурыИФункции.ЗаписатьДанныеВJSON(ВхПараметры,РезультатОтвет);

		СтруктураОтвет.Вставить("ФорматОтвета",HS_ОбщиеПроцедурыИФункции.ФорматОтветаJSON());

	КонецЕсли;	
КонецПроцедуры	
#КонецОбласти

#Область ПримерыЧасть4
//Пример из Части 4. Метод написан получения количество элементов по типу объекта
Процедура ПолучитьКоличествоЭлементовВариантЗапрос(СтруктураОтвет,СтруктураВхПараметров) Экспорт
	//Проверяем входящие параметры
	Если ВРег(СтруктураВхПараметров.МетодЗапроса) = ВРег("GET") Тогда 
		
		перНаименованиеОбъекта	= СтруктураВхПараметров.ПараметрыЗапроса.Получить("ItemName");
		НаименованиеОбъекта		= ?(перНаименованиеОбъекта = Неопределено,"",перНаименованиеОбъекта);

		перПорция	= СтруктураВхПараметров.ПараметрыЗапроса.Получить("top");
		Порция		= ?(перПорция = Неопределено,0,Число(перПорция));
		
	ИначеЕсли ВРег(СтруктураВхПараметров.МетодЗапроса) = ВРег("POST") Тогда
					
		ЧтениеJSON = Новый ЧтениеJSON;
		ЧтениеJSON.УстановитьСтроку(СтруктураВхПараметров.ТелоЗапроса);	
						
		Попытка
			ТелоЗапросаJSON = ПрочитатьJSON(ЧтениеJSON);
		Исключение
			HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,
				400,"Не удалось получить данные!",Ложь,"");
		КонецПопытки;
			
		Если СтруктураОтвет.Отработало Тогда
			Если ТипЗнч(ТелоЗапросаJSON) = Тип("Структура") Тогда 
									
				НаименованиеОбъекта = ?(ТелоЗапросаJSON.Свойство("ItemName"),ТелоЗапросаJSON.ItemName,"");	
				Порция = ?(ТелоЗапросаJSON.Свойство("top"),ТелоЗапросаJSON.top,0);
				
			Иначе
				HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,
					400,"Передана не структура!",Ложь,"");
			КонецЕсли;	
		КонецЕсли;	
	Иначе
		HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,
			501,"Метод: "+СтруктураВхПараметров.МетодЗапроса+" не поддерживается!",Ложь,"");	
	КонецЕсли;
	
	//Проверяем была ли ошибка
	Если СтруктураОтвет.Отработало Тогда		
		Если Не ПустаяСтрока(НаименованиеОбъекта) 
			 И Порция > 0 Тогда 
			 
			//Готовим структуру для дальнейшей работы 
			СтруктураЗапроса = Новый Структура("МетодЗапроса,ПараметрыЗапроса,ДатаЗапроса,НаименованиеОбъекта,Порция",
					ВРег("ПолучитьКоличествоЭлементовВариантЗапрос"),
					ВРег(НаименованиеОбъекта)+"_"+Формат(Порция, "ЧДЦ=0; ЧН=0; ЧГ="),
					ТекущаяДатаСеанса(),
					НаименованиеОбъекта,
					Порция); 
					
			//Проверяем был ли ранее подобный запрос. Считаем, что данные актуальны в дня.
			//Тоесть на следующий день данные будут неактуальны		
			HS_ОбщиеПроцедурыИФункции.ПолучитьИлиЗаписатьДанныеПредыдущегоЗапроса(СтруктураЗапроса,СтруктураОтвет);
			
			Если СтруктураОтвет.Отработало Тогда
				//Готовим ответ
				КоличествоЭлементов = ?(СтруктураЗапроса.РезультатОтвет.Свойство("КоличествоЭлементов"),
										СтруктураЗапроса.РезультатОтвет.КоличествоЭлементов, 
										0);
				
				ВхПараметры = HS_ОбщиеПроцедурыИФункции.СтандартныеПараметрыJSON();
				РезультатОтветJSON =  HS_ОбщиеПроцедурыИФункции.ЗаписатьДанныеВJSON(ВхПараметры,КоличествоЭлементов);

				СтруктураОтвет.ДанныеОтвета = РезультатОтветJSON;					
					
				СтруктураОтвет.Вставить("ФорматОтвета",HS_ОбщиеПроцедурыИФункции.ФорматОтветаJSON());
			КонецЕсли;			
		Иначе	
			HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,
					400,?(Порция=0,"top=0","Объект: """+НаименованиеОбъекта+""" не найден!"),Ложь,"");	
		КонецЕсли;
	КонецЕсли;	
КонецПроцедуры
//Пример из Части 4. Метод написан получения порции
Процедура ПолучитьПорциюЭлементовВариантЗапроса(СтруктураОтвет,СтруктураВхПараметров) Экспорт
	//Проверяем входящие параметры
	Если ВРег(СтруктураВхПараметров.МетодЗапроса) = ВРег("GET") Тогда 
		
		перНаименованиеОбъекта	= СтруктураВхПараметров.ПараметрыЗапроса.Получить("ItemName");
		НаименованиеОбъекта		= ?(перНаименованиеОбъекта = Неопределено,"",перНаименованиеОбъекта);

		перПорция	= СтруктураВхПараметров.ПараметрыЗапроса.Получить("top");
		Порция		= ?(перПорция = Неопределено,0,Число(перПорция));
		
		перСтраница	= СтруктураВхПараметров.ПараметрыЗапроса.Получить("page");
		текСтраница	= ?(перСтраница = Неопределено,0,Число(перСтраница));

		
	ИначеЕсли ВРег(СтруктураВхПараметров.МетодЗапроса) = ВРег("POST") Тогда
					
		ЧтениеJSON = Новый ЧтениеJSON;
		ЧтениеJSON.УстановитьСтроку(СтруктураВхПараметров.ТелоЗапроса);	
						
		Попытка
			ТелоЗапросаJSON = ПрочитатьJSON(ЧтениеJSON);
		Исключение
			HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,
				400,"Не удалось получить данные!",Ложь,"");
		КонецПопытки;
			
		Если СтруктураОтвет.Отработало Тогда
			Если ТипЗнч(ТелоЗапросаJSON) = Тип("Структура") Тогда 
									
				НаименованиеОбъекта = ?(ТелоЗапросаJSON.Свойство("ItemName"),ТелоЗапросаJSON.ItemName,"");	
				Порция = ?(ТелоЗапросаJSON.Свойство("top"),ТелоЗапросаJSON.top,0);
				текСтраница	= ?(ТелоЗапросаJSON.Свойство("page"),ТелоЗапросаJSON.page,0); 
				
			Иначе
				HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,
					400,"Передана не структура!",Ложь,"");
			КонецЕсли;	
		КонецЕсли;	
	Иначе
		HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,
			501,"Метод: "+СтруктураВхПараметров.МетодЗапроса+" не поддерживается!",Ложь,"");	
	КонецЕсли;
	
	//Проверяем была ли ошибка
	Если СтруктураОтвет.Отработало Тогда		
		Если Не ПустаяСтрока(НаименованиеОбъекта) 
			 И Порция > 0 
			 И текСтраница >= 0 Тогда 
			 
			//Готовим структуру для дальнейшей работы
			СтруктураЗапроса = Новый Структура("МетодЗапроса,ПараметрыЗапроса,ДатаЗапроса,НаименованиеОбъекта,Порция,Страница",
					ВРег("ПолучитьКоличествоЭлементовВариантЗапрос"),
					ВРег(НаименованиеОбъекта)+"_"+Формат(Порция, "ЧДЦ=0; ЧН=0; ЧГ="),
					ТекущаяДатаСеанса(),
					НаименованиеОбъекта,
					Порция,
					текСтраница); 
				
		    //Проверяем был ли ранее подобный запрос. Считаем, что данные актуальны в дня.
			//Тоесть на следующий день данные будут неактуальны
		    HS_ОбщиеПроцедурыИФункции.ПолучитьИлиЗаписатьДанныеПредыдущегоЗапроса(СтруктураЗапроса,СтруктураОтвет);
			 
			Если СтруктураОтвет.Отработало Тогда
				//Готовим ответ
				МассивПоследних = ?(СтруктураЗапроса.РезультатОтвет.Свойство("МассивПоследних"),
										СтруктураЗапроса.РезультатОтвет.МассивПоследних, 
										Новый Массив);
								
				РезультатОтвет = Новый Массив;
				Если МассивПоследних.Количество() > 0 
					И МассивПоследних.Количество() >= текСтраница Тогда 
					//Проверяем справочник Иерархический или нет
					перЕстьГруппы = ?(МассивПоследних[0].Метаданные().Иерархический,Истина,Ложь);
					
					//Получаем нужную порцию
					Запрос = Новый Запрос;
					Запрос.Текст = 
						"ВЫБРАТЬ ПЕРВЫЕ "+Формат(Порция, "ЧДЦ=0; ЧН=0; ЧГ=")+"
						|	Ссылка КАК Ссылка,
						|	ПометкаУдаления КАК DeletionMark,
						|	Код КАК Code,
						|	Наименование КАК Description
						|	//[ЕстьГруппы]//, ЭтоГруппа КАК IsFolder
						|ИЗ
						|	[ИмяТаблицы] ГДЕ Ссылка > &Ссылка УПОРЯДОЧИТЬ ПО Ссылка";
					Запрос.Текст = СтрЗаменить(Запрос.Текст, "[ИмяТаблицы]", НаименованиеОбъекта);
					Если перЕстьГруппы Тогда 
						Запрос.Текст = СтрЗаменить(Запрос.Текст, "//[ЕстьГруппы]//", "");	
					КонецЕсли;	
					
					Запрос.УстановитьПараметр("Ссылка",МассивПоследних[текСтраница]);
					
					РезультатЗапроса = Запрос.Выполнить();
					
					ВыборкаДетальныеЗаписи = РезультатЗапроса.Выбрать();
					
					Пока ВыборкаДетальныеЗаписи.Следующий() Цикл
						текЭлМасс = Новый Структура;
						текЭлМасс.Вставить("Ref_Key",		XMLСтрока(ВыборкаДетальныеЗаписи.Ссылка));
						текЭлМасс.Вставить("Description",	ВыборкаДетальныеЗаписи.Description);
						текЭлМасс.Вставить("Code",			ВыборкаДетальныеЗаписи.Code);
						текЭлМасс.Вставить("DeletionMark",	ВыборкаДетальныеЗаписи.DeletionMark);
						Если перЕстьГруппы Тогда 
							текЭлМасс.Вставить("IsFolder",	ВыборкаДетальныеЗаписи.IsFolder);	
						КонецЕсли;	
						
						РезультатОтвет.Добавить(текЭлМасс);
					КонецЦикла;					
				КонецЕсли;	
				
				стрРезультатОтвет = Новый Структура("value",РезультатОтвет);
				
				ВхПараметры = HS_ОбщиеПроцедурыИФункции.СтандартныеПараметрыJSON();
				//Делаем красивый вывод данных (Эстетика чисто для глаза)
				ВхПараметры.ПереносСтрок = ПереносСтрокJSON.Авто;
				
				РезультатОтветJSON =  HS_ОбщиеПроцедурыИФункции.ЗаписатьДанныеВJSON(ВхПараметры,стрРезультатОтвет);

				СтруктураОтвет.ДанныеОтвета = РезультатОтветJSON;					
					
				СтруктураОтвет.Вставить("ФорматОтвета",HS_ОбщиеПроцедурыИФункции.ФорматОтветаJSON());
			КонецЕсли;			
		Иначе	
			HS_ОбщиеПроцедурыИФункции.ЗаполнитьСтруктуруОтвета(СтруктураОтвет,
					400,?(Порция=0,"top=0 или page<0","Объект: """+НаименованиеОбъекта+""" не найден!"),Ложь,"");	
		КонецЕсли;
	КонецЕсли;	
КонецПроцедуры
#КонецОбласти

#КонецОбласти