﻿//Заполняем структуру ответа
Процедура ЗаполнитьСтруктуруОтвета(СтруктураОтвет,КодОтвета,ТекстОшибки,Отработало,ДанныеОтвета) Экспорт
	СтруктураОтвет.КодОтвета 	= КодОтвета;
	СтруктураОтвет.ТекстОшибки	= ТекстОшибки;
	СтруктураОтвет.Отработало	= Отработало;
	СтруктураОтвет.ДанныеОтвета = ДанныеОтвета;	
КонецПроцедуры

Функция БазаФайловая()
	СтрокаСоединенияСБД = СтрокаСоединенияИнформационнойБазы();
	// в зависимости от того файловый это вариант БД или нет,  по-разному отображается путь в БД 
	ПозицияПоиска = Найти(Врег(СтрокаСоединенияСБД), "FILE=");
	Если ПозицияПоиска = 1 тогда
		Возврат Истина;	
	Иначе 
		Возврат Ложь;
	КонецЕсли;              	
КонецФункции    

#Область ВспомогательныеПроцедурыФункцииМетодов
//Считываем или создаем элемент справочника HS_ХранилищеРезультатов 
//Вспомогательная процедура методов: ПолучитьПорциюЭлементовВариантЗапроса, ПолучитьКоличествоЭлементовВариантЗапрос
Процедура ПолучитьИлиЗаписатьДанныеПредыдущегоЗапроса(СтруктураЗапроса,СтруктураОтвет) Экспорт
	НайденнаяСсылка = ПолучитьПредыдущийЗапрос(СтруктураЗапроса); 
	Если Не ЗначениеЗаполнено(НайденнаяСсылка) Тогда  
		
		КоличествоЭлементов = ПолучитьКоличествоЭлементов(СтруктураЗапроса.НаименованиеОбъекта); 
		Если КоличествоЭлементов = -1 Тогда 
			ЗаполнитьСтруктуруОтвета(СтруктураОтвет,
			400,"Объект: """+СтруктураЗапроса.НаименованиеОбъекта+""" не найден!",Ложь,"");
		Иначе
			МассивПоследних = Новый Массив;
			МассивПоследних.Добавить(ПустаяСсылкаПоНаименованиеОбъекта(СтруктураЗапроса.НаименованиеОбъекта));
			Если КоличествоЭлементов = 0 Тогда 
				КоличествоСтраниц = 0;
			Иначе 	
				//Получаем количество страниц
				перДоОкругления = КоличествоЭлементов/СтруктураЗапроса.Порция;
				КоличествоСтраниц = Окр(перДоОкругления+0.5,0,РежимОкругления.Окр15как20);
				
				//Заполняем МассивПоследних ссылок
				ПродолжаемЗаполнять = Истина;
				ПромежуточнаяСтруктура = Новый Структура("Продолжаем,Ссылка",Истина,Неопределено);
				Пока ПродолжаемЗаполнять Цикл 
					ПромежуточнаяСтруктура = 
					ПолучитьПоследнийЭлементПорции(ПромежуточнаяСтруктура,СтруктураЗапроса.НаименованиеОбъекта,СтруктураЗапроса.Порция);
					
					ПродолжаемЗаполнять = ПромежуточнаяСтруктура.Продолжаем;
					
					Если ПродолжаемЗаполнять Тогда
						МассивПоследних.Добавить(ПромежуточнаяСтруктура.Ссылка);
					КонецЕсли;	
				КонецЦикла;	
				
				
			КонецЕсли;
			
			РезультатОтвет = Новый Структура("КоличествоЭлементов,МассивПоследних",
			КоличествоЭлементов,
			МассивПоследних);
						
			ТекущийОбъект = Справочники.HS_ХранилищеРезультатов.СоздатьЭлемент();
			ТекущийОбъект.МетодЗапроса 		= СтруктураЗапроса.МетодЗапроса; 
			ТекущийОбъект.ПараметрыЗапроса	= СтруктураЗапроса.ПараметрыЗапроса;
			ТекущийОбъект.ДатаЗапроса		= СтруктураЗапроса.ДатаЗапроса;
			
			ТекущийОбъект.УстановитьНовыйКод();
			
			ТекущийОбъект.Результат = Новый ХранилищеЗначения(РезультатОтвет, Новый СжатиеДанных(9));
			
			ТекущийОбъект.ОбменДанными.Загрузка = Истина;
			ТекущийОбъект.Записать();
		КонецЕсли;
		
	Иначе 
		
		РезультатОтвет = НайденнаяСсылка.Результат.Получить();
		
	КонецЕсли;
	
	СтруктураЗапроса.Вставить("РезультатОтвет",РезультатОтвет)
КонецПроцедуры	
#КонецОбласти


#Область РаботаСДанными
//Получаем дату из входных параметров
Функция ПолучитьДатуВремяИзСтроки(ДатаВремя) Экспорт
	
	Результат = Неопределено;
	ДатаВремя = СтрЗаменить(ДатаВремя, "-", "");
	ДатаВремя = СтрЗаменить(ДатаВремя, ":", "");
	Если СтрДлина(ДатаВремя) - Найти(ДатаВремя, " ") = 5 Тогда // время в формате Ч:ММ:СС
		ДатаВремя = СтрЗаменить(ДатаВремя, " ", "0");
	ИначеЕсли Найти(ДатаВремя, "T") > 0 Тогда //время в формате ГГГГММДДTЧЧММСС
		ДатаВремя = СтрЗаменить(ДатаВремя, "T", "");
	Иначе // время в формате ЧЧ:ММ:СС
		ДатаВремя = СтрЗаменить(ДатаВремя, " ", "");
	КонецЕсли;
	
	ОписаниеТипа = Новый ОписаниеТипов("Дата");
	Результат = ОписаниеТипа.ПривестиЗначение(ДатаВремя);  // дата и время в виде "ГГГГММДДЧЧММСС"
	Если Не ЗначениеЗаполнено(Результат) Тогда
		Результат = ОписаниеТипа.ПривестиЗначение(Лев(ДатаВремя, 8));  // только дата "ГГГГММДД"
	КонецЕсли;

	Возврат Результат;
	
КонецФункции
//Получаем ПустуюСсылку
Функция ПустаяСсылкаПоНаименованиеОбъекта(НаименованиеОбъекта) Экспорт 
	Запрос = Новый Запрос;
	Запрос.Текст = "ВЫБРАТЬ ЗНАЧЕНИЕ("+НаименованиеОбъекта+".ПустаяСсылка) как Ссылка";
		
	РезультатЗапроса = Запрос.Выполнить();
		
	Выборка = РезультатЗапроса.Выбрать();

	Если Выборка.Следующий() Тогда
		Возврат Выборка.Ссылка; 
	Иначе 
		Возврат Неопределено;
	КонецЕсли;

КонецФункции	
//Получаем ссылку на Справочник.HS_ХранилищеРезультатов по заданной структуре
Функция ПолучитьПредыдущийЗапрос(СтруктураЗапроса) Экспорт 
	Запрос = Новый Запрос;
	Запрос.Текст = 
		"ВЫБРАТЬ ПЕРВЫЕ 1
		|	HS_ХранилищеРезультатов.Ссылка КАК Ссылка
		|ИЗ
		|	Справочник.HS_ХранилищеРезультатов КАК HS_ХранилищеРезультатов
		|ГДЕ
		|	НЕ HS_ХранилищеРезультатов.ПометкаУдаления
		|	И HS_ХранилищеРезультатов.МетодЗапроса = &МетодЗапроса
		|	И HS_ХранилищеРезультатов.ПараметрыЗапроса = &ПараметрыЗапроса
		|	И HS_ХранилищеРезультатов.ДатаЗапроса МЕЖДУ &ДатаЗапросаН И &ДатаЗапросаК";
	
	Запрос.УстановитьПараметр("ДатаЗапросаК", КонецДня(СтруктураЗапроса.ДатаЗапроса));
	Запрос.УстановитьПараметр("ДатаЗапросаН", НачалоДня(СтруктураЗапроса.ДатаЗапроса));
	Запрос.УстановитьПараметр("МетодЗапроса", СтруктураЗапроса.МетодЗапроса);
	Запрос.УстановитьПараметр("ПараметрыЗапроса", СтруктураЗапроса.ПараметрыЗапроса);
	
	РезультатЗапроса = Запрос.Выполнить();
	
	ВыборкаДетальныеЗаписи = РезультатЗапроса.Выбрать();
	
	Если ВыборкаДетальныеЗаписи.Следующий() Тогда 
		Возврат ВыборкаДетальныеЗаписи.Ссылка;
	Иначе	
		Возврат Неопределено;
	КонецЕсли;

КонецФункции		
//Получить количество элементов запросом
Функция ПолучитьКоличествоЭлементов(НаименованиеОбъекта) Экспорт 
	Запрос = Новый Запрос;
	Запрос.Текст = 
		"ВЫБРАТЬ
		|	КОЛИЧЕСТВО(*) КАК Количество
		|ИЗ
		|	[ИмяТаблицы]
		|";
	Если НЕ ПустаяСтрока(НаименованиеОбъекта) Тогда 
		Запрос.Текст = СтрЗаменить(Запрос.Текст, "[ИмяТаблицы]", НаименованиеОбъекта);
	Иначе
		Возврат -1;
	КонецЕсли;
	
	Попытка
		РезультатЗапроса = Запрос.Выполнить();
		Если РезультатЗапроса.Пустой() Тогда 
			Возврат 0;
		Иначе 	
			ВыборкаДетальныеЗаписи = РезультатЗапроса.Выбрать();
			Если ВыборкаДетальныеЗаписи.Следующий() Тогда 
				Возврат ВыборкаДетальныеЗаписи.Количество;
			КонецЕсли;
		КонецЕсли;	
	Исключение
		Возврат -1;
	КонецПопытки;
КонецФункции	
//Если в порции 1000 элементов, то мы получим 1000-й
Функция ПолучитьПоследнийЭлементПорции(ВхСтруктура,НаименованиеОбъекта,Порция) Экспорт 
	//ПромежуточнаяСтруктура = Новый Структура("Продолжаем,Ссылка",Истина,Неопределено);
	Запрос = Новый Запрос;
	Запрос.Текст = 
		"ВЫБРАТЬ ПЕРВЫЕ "+Формат(Порция, "ЧДЦ=0; ЧН=0; ЧГ=")+"
		|	Ссылка КАК Ссылка
		|ПОМЕСТИТЬ ВременнаяТаблица
		|ИЗ
		|	[ИмяТаблицы]
		|ГДЕ
		|	Ссылка > &Ссылка
		|
		|УПОРЯДОЧИТЬ ПО
		|	Ссылка
		|;
		|
		|////////////////////////////////////////////////////////////////////////////////
		|ВЫБРАТЬ
		|	ВременнаяТаблица.Ссылка КАК Ссылка
		|ИЗ
		|	ВременнаяТаблица КАК ВременнаяТаблица
		|ГДЕ
		|	НЕ ВременнаяТаблица.Ссылка В
		|				(ВЫБРАТЬ ПЕРВЫЕ "+ Формат(Порция-1, "ЧДЦ=0; ЧН=0; ЧГ=")+"
		|					тз.Ссылка
		|				ИЗ
		|					ВременнаяТаблица КАК тз)";
		
	Запрос.Текст = СтрЗаменить(Запрос.Текст, "[ИмяТаблицы]", НаименованиеОбъекта);	
	Если ВхСтруктура.Ссылка = Неопределено Тогда 
		Запрос.Текст = СтрЗаменить(Запрос.Текст, "&Ссылка", "ЗНАЧЕНИЕ("+НаименованиеОбъекта+".ПустаяСсылка)");		
	Иначе		
		Запрос.УстановитьПараметр("Ссылка", ВхСтруктура.Ссылка);
	КонецЕсли;
	РезультатЗапроса = Запрос.Выполнить();
	
	Если РезультатЗапроса.Пустой() Тогда 
		ВхСтруктура.Продолжаем = Ложь;
	Иначе	
		ВыборкаДетальныеЗаписи = РезультатЗапроса.Выбрать();	
		Если ВыборкаДетальныеЗаписи.Следующий() Тогда
			ВхСтруктура.Продолжаем	= Истина;
			ВхСтруктура.Ссылка 		= ВыборкаДетальныеЗаписи.Ссылка;
		Иначе
			ВхСтруктура.Продолжаем = Ложь;
		КонецЕсли;
	КонецЕсли;
	
	Возврат ВхСтруктура;
	
КонецФункции

Функция ПреобразоватьТаблицуЗначенийВМассивСтруктур(п_ТЗ) Экспорт
	
	Массив = Новый Массив();
	
	СтруктураСтрокой = "";
	НужнаЗапятая 	 = Ложь;
	
	Для Каждого Колонка Из п_ТЗ.Колонки Цикл
		
		Если НужнаЗапятая Тогда
			СтруктураСтрокой = СтруктураСтрокой + ",";
		КонецЕсли;
		
		СтруктураСтрокой = СтруктураСтрокой + Колонка.Имя;
		НужнаЗапятая     = Истина;
		
	КонецЦикла;
	
	Для Каждого Строка Из п_ТЗ Цикл
		
		НоваяСтрока = Новый Структура(СтруктураСтрокой);
		ЗаполнитьЗначенияСвойств(НоваяСтрока, Строка);
		
		Массив.Добавить(НоваяСтрока);
		
	КонецЦикла;
	
	Возврат Массив;

КонецФункции

#КонецОбласти

#Область СерилизацияДесирилизация
Функция ЗаписатьДанныеВJSON(ВхПараметры,РезультатОтвет) Экспорт
	ПараметрыJSON	= Новый ПараметрыЗаписиJSON(ВхПараметры.ПереносСтрок,
							ВхПараметры.СимволОтступа,
							ВхПараметры.ИспользоватьДвойныеКавычки,
							ВхПараметры.ЭкранированиеСимволов,
							ВхПараметры.ЭкранироватьУгловыеСкобки,
							ВхПараметры.ЭкранироватьАмперсанд,
							ВхПараметры.ЭкранироватьОдинарныеКавычки,
							ВхПараметры.ЭкранироватьРазделителиСтрок,
							ВхПараметры.ЭкранироватьСлешь);
	ЗаписьJSON		= Новый ЗаписьJSON;
	ЗаписьJSON.ПроверятьСтруктуру = Истина;
	ЗаписьJSON.УстановитьСтроку(ПараметрыJSON);
	Попытка
		ЗаписатьJSON(ЗаписьJSON, РезультатОтвет);
		Результат = ЗаписьJSON.Закрыть();
	Исключение
		Результат = "";	
	КонецПопытки;
	
	Возврат Результат;
	
КонецФункции	

Функция СтандартныеПараметрыJSON() Экспорт
	ПараметрыJSON	= Новый Структура;	
	ПараметрыJSON.Вставить("ПереносСтрок",ПереносСтрокJSON.Нет);
	ПараметрыJSON.Вставить("СимволОтступа"," ");
	ПараметрыJSON.Вставить("ИспользоватьДвойныеКавычки",Истина);
	ПараметрыJSON.Вставить("ЭкранированиеСимволов",ЭкранированиеСимволовJSON.Нет);
	ПараметрыJSON.Вставить("ЭкранироватьУгловыеСкобки",Ложь);
	ПараметрыJSON.Вставить("ЭкранироватьАмперсанд",Ложь);
	ПараметрыJSON.Вставить("ЭкранироватьОдинарныеКавычки",Ложь);
	ПараметрыJSON.Вставить("ЭкранироватьРазделителиСтрок",Ложь);
	ПараметрыJSON.Вставить("ЭкранироватьСлешь",Ложь);

	Возврат ПараметрыJSON;	
	
КонецФункции
#КонецОбласти

#Область ФорматыОтвета
Процедура ВозвращаемНужныйФорматОтвета(Ответ,СтруктураОтвет) Экспорт
	
	Если СтруктураОтвет.Свойство("ФорматОтвета") Тогда 
		ФорматОтвета = СтруктураОтвет.ФорматОтвета;
	Иначе
		ФорматОтвета = "";
	КонецЕсли;	

	Если ВРег(ФорматОтвета) = Врег(ФорматОтветаJSON()) Тогда 
		Ответ.Заголовки.Вставить("Content-Type","application/json; charset=utf-8");
	Иначе 	
		Ответ.Заголовки.Вставить("Content-Type","text/html; charset=utf-8");
	КонецЕсли;
КонецПроцедуры

Функция ФорматОтветаJSON() Экспорт 
	Возврат "JSON";	
КонецФункции
#КонецОбласти

#Область РаботаСФоновымиЗаданиями
Функция НайтиЗадание(Идентификатор) Экспорт
	// Считывает состояние фонового задания по переданному идентификатору.
	//
	// Параметры:
	//   Идентификатор - УникальныйИдентификатор - Идентификатор фонового задания.
	//
	// Возвращаемое значение:
	//   Неопределено - Задание не найдено.
	//   Структура - Сведения о задании.
	//       * Выполняется - Булево - Истина когда фоновое задание еще выполняется.
	//       * Успешно     - Булево - Истина когда сеанс фонового задания завершился без ошибок.
	//       * Ошибка      - Строка, ИнформацияОбОшибке, Неопределено - Описание ошибки.
	//
	УстановитьПривилегированныйРежим(Истина);
	
	Результат = Новый Структура("Выполняется, Успех, Ошибка", Ложь, Ложь, Неопределено);
	Если Идентификатор = Неопределено Тогда
		Возврат Результат;
	КонецЕсли;
		
	Задание = ФоновыеЗадания.НайтиПоУникальномуИдентификатору(Идентификатор);
	Если Задание = Неопределено Тогда
		Возврат Результат;
	КонецЕсли;
	
	Если Задание.Состояние = СостояниеФоновогоЗадания.Активно Тогда
		Результат.Выполняется = Истина;
	Иначе
		Результат.Выполняется = Ложь;
		Если Задание.Состояние = СостояниеФоновогоЗадания.Завершено Тогда
			Результат.Успех = Истина;
		Иначе
			Результат.Успех = Ложь;
			Результат.Ошибка = Задание.ИнформацияОбОшибке;
		КонецЕсли;
	КонецЕсли;
	
	Возврат Результат;
КонецФункции

#КонецОбласти